Name: readline4.3
Version: 4.3
Release: alt8

Summary: A library for editing typed in command lines
License: GPL
Group: System/Libraries
Url: http://www.gnu.org/software/readline/

%define srcname readline-%version
Source: ftp://ftp.gnu.org/gnu/readline/%srcname.tar.bz2

Patch1: ftp://ftp.cwru.edu/pub/bash/%srcname-patches/readline43-001
Patch2: ftp://ftp.cwru.edu/pub/bash/%srcname-patches/readline43-002
Patch3: ftp://ftp.cwru.edu/pub/bash/%srcname-patches/readline43-003
Patch4: ftp://ftp.cwru.edu/pub/bash/%srcname-patches/readline43-004
Patch5: ftp://ftp.cwru.edu/pub/bash/%srcname-patches/readline43-005

Patch11: readline-4.1-rh-man.patch
Patch12: readline-4.3-alt-nls.patch
Patch13: readline-4.3-alt-warning_fixes.patch
Patch14: readline-4.3-rh-histexpand-utf8.patch
Patch15: readline-4.3-alt-shlib.patch

Patch21: readline-4.3-deb-delete.patch
Patch22: readline-4.3-deb-alt-inputrc.patch
Patch23: readline-4.3-deb-header.patch
Patch24: readline-4.3-deb-slow-multibyte.patch
Patch25: readline-4.3-deb-doc.patch

# Automatically added by buildreq on Mon Sep 02 2002
BuildRequires: libtinfo-devel

%def_disable devel

%define compat_list 3 3.0 4.0 4.1 4.2
%define lib_suffix %nil
%{expand:%%define lib_suffix %(test %_lib != lib64 && echo %%nil || echo '()(64bit)')}

%package -n lib%name
Summary: A library for editing typed in command lines
Group: System/Libraries
Obsoletes: readline
Provides: readline = %version-%release
%if "%compat_list" != ""
Provides: %(for n in %compat_list; do echo -n "libhistory.so.$n%lib_suffix libreadline.so.$n%lib_suffix "; done)
%endif
Conflicts: libreadline < 5.0

%package -n lib%name-devel
Summary: Files needed to develop programs which use the readline library
Group: Development/C
Provides: readline-devel = %version-%release
Obsoletes: readline-devel
PreReq: lib%name = %version-%release
Requires(post): %install_info
Requires(preun): %uninstall_info
Conflicts: libreadline-devel

%package -n lib%name-devel-static
Summary: Files needed to develop statically linked programs which use the readline library
Group: Development/C
Requires: lib%name-devel = %version-%release
Conflicts: libreadline-devel-static

%description
The readline library reads a line from the terminal and returns it,
allowing the user to edit the line with standard emacs editing keys.

%description -n lib%name
The readline library reads a line from the terminal and returns it,
allowing the user to edit the line with standard emacs editing keys.

%description -n lib%name-devel
The readline library reads a line from the terminal and returns it,
allowing the user to edit the line with standard emacs editing keys.

This package contains the files needed to develop programs which use
the readline library to provide an easy to use and more intuitive
command line interface for users.

%description -n lib%name-devel-static
The readline library reads a line from the terminal and returns it,
allowing the user to edit the line with standard emacs editing keys.

This package contains the files needed to develop statically linked
programs which use the readline library to provide an easy to use
and more intuitive command line interface for users.

%prep
%setup -q -n %srcname

%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0

%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1

%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1

find -type f -name \*.orig -delete -print

%build
# This is required to fix some "implicit declaration" warnings.
%add_optflags -D_GNU_SOURCE

# Link with libtinfo unconditionally.
export bash_cv_termcap_lib=libtinfo

# Workaround for buildreq/strace.
%{?__buildreqs:export bash_cv_must_reinstall_sighandlers=no}

%configure
rm -f doc/*.info

%make_build all examples documentation

%install
%makeinstall

# Relocate shared libraries from %_libdir/ to /%_lib/.
mkdir -p %buildroot/%_lib
for f in %buildroot%_libdir/*.so; do
	t=`objdump -p "$f" |awk '/SONAME/ {print $2}'`
	[ -n "$t" ]
	ln -snf ../../%_lib/"$t" "$f"
done
mv %buildroot%_libdir/*.so.* %buildroot/%_lib/

for n in readline history; do
	t=`objdump -p "%buildroot%_libdir/lib$n.so" |awk '/SONAME/ {print $2}'`
	for v in %compat_list; do
		ln -s "../../%_lib/$t" "%buildroot%_libdir/lib$n.so.$v"
	done
done

# Relocate and fix documentation.
%define docdir %_docdir/readline-%version
mkdir -p %buildroot%docdir
cp -a README CHANGE* USAGE examples \
	%buildroot%docdir/
bzip2 -9 %buildroot%docdir/CHANGE*
cp -p config.h posixstat.h \
	%buildroot%docdir/examples/
pushd %buildroot%docdir/examples
	%__subst 's,^\(top_srcdir *=\).*,\1 %_includedir/readline,g;s,^\(\(LDFLAGS\|READLINE_LIB\|HISTORY_LIB\) *=\).*,\1,g' Makefile
	make clean
	find -type f -name \*.o -delete
popd

%set_verify_elf_method strict

%post -n lib%name -p %post_ldconfig
%postun -n lib%name -p %postun_ldconfig

%post -n lib%name-devel
%install_info {readline,history,rluserman}.info

%preun -n lib%name-devel
%uninstall_info {readline,history,rluserman}.info

%files -n lib%name
/%_lib/*
%if "%compat_list" != ""
%_libdir/*.so.*
%endif

%if_enabled devel
%files -n lib%name-devel
%_libdir/*.so
%_includedir/*
%_mandir/man?/*
%_infodir/*.info*
%docdir

%files -n lib%name-devel-static
%_libdir/*.a
%endif

%changelog
* Thu Mar 23 2006 Dmitry V. Levin <ldv@altlinux.org> 4.3-alt8
- Backported specfile fixes from 5.1.4-alt1.

* Mon Jan 23 2006 Sergey Vlasov <vsu@altlinux.ru> 4.3-alt7.0.1
- Converted to compatibility package.
- Remove *.o files from examples to fix failure of new RPM checks.
- Do not build development packages by default.

* Thu Feb 10 2005 Dmitry V. Levin <ldv@altlinux.org> 4.3-alt7
- Fixed multilib (closes #4895).

* Wed Apr 28 2004 Dmitry V. Levin <ldv@altlinux.org> 4.3-alt6
- Rebuilt with glibc-2.3.x.

* Sun Mar 21 2004 Dmitry V. Levin <ldv@altlinux.org> 4.3-alt5
- Applied 3 more official patches.
- Merged to official patches:
  + chet-mbyte
  + alt-mbutil-fixes
- Applied 3 more debian patches:
  + include stdio.h in readline.h and history.h;
  + speedup long lines processing in multibyte locales;
  + fix typo in readline(3) manpage.
- Linked readline library with -lhistory -ltinfo.

* Tue Dec 24 2002 Dmitry V. Levin <ldv@altlinux.org> 4.3-alt4
- mbutil.c (_rl_get_char_len,_rl_adjust_point):
  Fixed several potential null dereferences.

* Sat Dec 14 2002 Dmitry V. Levin <ldv@altlinux.org> 4.3-alt3
- Fixed histexpand utf8 problem (rh).
- nls.c (_rl_init_eightbit): Instead of setting the LC_CTYPE
  locale category from environment variables, query it from
  the program's current locale.
- Prevent prompt overwriting output for multibyte locales,
  patch from Chet Ramey.

* Sun Sep 29 2002 Dmitry V. Levin <ldv@altlinux.org> 4.3-alt2
- Applied two "official" patches from
  ftp://ftp.cwru.edu/pub/bash/readline-4.3-patches/.
- Merged two debian patches:
  + handle key sequence sent by the Delete key, if any;
  + support for /etc/inputrc in addition to ~/inputrc.

* Sun Sep 15 2002 Dmitry V. Levin <ldv@altlinux.org> 4.3-alt1
- 4.3
- Patch out rpath.
- Fixed most of compilation warnings.
- Added 4.2 shlib symlink for compatibility.
- Relocated documentation, fixed examples.

* Sun Sep 01 2002 Dmitry V. Levin <ldv@altlinux.org> 4.2a-alt3
- Fixed library symlinks generation.
- Use subst instead of perl for build.
- Relocated compatibility symlinks from /%_lib/ to %_libdir/.
- Updated devel-static requirements.

* Sat Jun 29 2002 Dmitry V. Levin <ldv@altlinux.org> 4.2a-alt2
- Updated buildrequires.

* Fri Mar 15 2002 Dmitry V. Levin <ldv@alt-linux.org> 4.2a-alt1
- 4.2a, dropped outdated patches.

* Mon Oct 08 2001 Dmitry V. Levin <ldv@altlinux.ru> 4.2-alt5
- Use strpbrk implementation from glibc (rh).

* Mon Sep 10 2001 Dmitry V. Levin <ldv@altlinux.ru> 4.2-alt4
- Make sure headers can be included from C++ applications.

* Thu May 24 2001 Dmitry V. Levin <ldv@altlinux.ru> 4.2-alt3
- Dropped buggy resize patch.
- Updated requires according to new policy.

* Tue May 08 2001 Dmitry V. Levin <ldv@altlinux.ru> 4.2-alt2
- Fixed requires.

* Wed Apr 11 2001 Dmitry V. Levin <ldv@altlinux.ru> 4.2-alt1
- 4.2
- Libification.

* Mon Mar 19 2001 Dmitry V. Levin <ldv@altlinux.ru> 4.1-ipl9mdk
- Fixed provides list.

* Mon Oct 30 2000 Dmitry V. Levin <ldv@fandra.org> 4.1-ipl8mdk
- Check for arithmetic overflow (by RH).
- FHSification.

* Tue Jun 13 2000 Dmitry V. Levin <ldv@fandra.org> 4.1-ipl7mdk
* RE and Fandra adaptions.

* Mon Jun 12 2000 Pixel <pixel@mandrakesoft.com> 4.1-7mdk
- add .so's in /usr/lib for -devel
- move .a's in /usr/lib

* Mon Jun 12 2000 Pixel <pixel@mandrakesoft.com> 4.1-6mdk
- move doc to -devel (was partially done, hurk), that way, no more prerequisite
on shell.

* Fri Jun  9 2000 Frederic Lepied <flepied@mandrakesoft.com> 4.1-5mdk
- move libraries in /lib.

* Fri Apr  7 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.1-4mdk
- s|/usr/local/bin/perl|/usr/bin/perl|;

* Fri Apr 07 2000 Christopher Molnar <molnarc@mandrakesoft.com> 4.1-3mdk
- add documentation, support and examples

* Thu Mar 23 2000 Pixel <pixel@mandrakesoft.com> 4.1-2mdk
- remove rluserman install-info

* Thu Mar 23 2000 Pixel <pixel@mandrakesoft.com> 4.1-1mdk
- new version
- much cleanup
- patch for strange buggy Makefile
- remove the trigger, i prefer require

* Tue Feb  8 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.0-8mdk
- Make sure to have the *so in the %files(>#751).

* Sun Feb  6 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.0-7mdk
- Librairies in /usr/lib no binaries on /bin/ or /sbin need
  libreadline.(#751).

* Sun Feb 06 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Leave libraries in /usr/lib/

* Tue Nov 09 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Fix wrong link (#426).

* Mon Oct 25 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- Build Release.

* Sun Jul 11 1999 Bernhard Rosenkraenzer <bero@mandrakesoft.de>
- move dynamic libraries to /lib rather than /usr/lib - a dynamically linked
  primary shell depends on them to run...
- Install info pages in %trigger -- info - readline has to be installed
  before info because bash depends on it.

* Tue Apr 13 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Mandrake adptation.

* Sat Apr 10 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- set compatibility links + provides for older versions, like those
  used in Red Hat 6.0
- add de locale

* Wed Mar 10 1999 Bernhard Rosenkraenzer <bero@microsoft.sucks.eu.org>
- relink with ncurses 5.0

* Sat Dec  5 1998 Bernhard Rosenkraenzer <bero@microsoft.sucks.eu.org>
- bzip2 info/man pages
- use ncurses rather than termcap

* Sun Jul 26 1998 Jeff Johnson <jbj@redhat.com>
- updated to 2.2.1

* Wed May 06 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed May 06 1998 Cristian Gafton <gafton@redhat.com>
- don't package /usr/info/dir

* Thu Apr 30 1998 Cristian Gafton <gafton@redhat.com>
- devel package moved to Development/Libraries

* Tue Apr 21 1998 Cristian Gafton <gafton@redhat.com>
- updated to 2.2

* Tue Oct 14 1997 Donnie Barnes <djb@redhat.com>
- spec file cleanups

* Fri Oct 10 1997 Erik Troan <ewt@redhat.com>
- added proper sonames

* Tue Jul 08 1997 Erik Troan <ewt@redhat.com>
- updated to readline 2.1

* Tue Jun 03 1997 Erik Troan <ewt@redhat.com>
- built against glibc
